/*
 * CopyHandler.java
 *
 * Created on 6  2002 ., 11:54
 */

package com.fn.spcave.compiler;


import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;


/**
 *
 * @author  asso
 */
public class CopyHandler implements FileHandler {
    
    /** Creates a new instance of CopyHandler */
    public CopyHandler() {
    }
    
    public void processFile(File file, File outputDir, String relativePath, String fileName, 
            Locale locale, String fileType, Compiler compiler) throws ScException 
    {
        try {
            if (! outputDir.exists())
                outputDir.mkdirs();
            BufferedInputStream in = new BufferedInputStream(new FileInputStream(file));
            File outputFile = new File(outputDir, fileName + "." + fileType);
System.out.println("Copying: " + file.getPath() + " to " + outputFile.getPath());
            BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(outputFile));
            byte buffer[] = new byte[10240];
            int len;
            do {
                len = in.read(buffer);
                if (len > 0) out.write(buffer, 0, len);
            } while (len > 0);
            out.close();
            in.close();
        } catch (Exception e) {
            throw new ScException("Error copying file: " + e.getMessage());
        }
    }
    
}
