/*
 * IfKeyword.java
 *
 * Created on 19  2002 ., 12:40
 */

package com.fn.spcave.compiler;


import java.util.List;


/**
 *
 * @author  asso
 */
public class IfKeyword extends KeywordInstruction {
    
    private int elsePosition = -1;
    
    /** Creates a new instance of IfKeyword */
    public IfKeyword(Lexical lexical, String source, int line, int position, 
            List arguments) throws ScException 
    {
        super(lexical, source, line, position, arguments);
        if (arguments.size() != 1)
            throw new ScException(getErrorPos() + "if takes exacly one argument");
    }
    
    public int processKeyword(Interpreter interp) throws ScException {
        int pos = getPosition() + 1;
        boolean res = ((Expression)getArguments().get(0)).asBoolean(interp);
        Instruction instr = getLexical().getInstruction(pos);
        if (instr.getCode() != BeginInstruction.BEGIN_CODE)
            throw new ScException(getErrorPos() + "@if must followed by @begin - @end block");
        BeginInstruction bi = (BeginInstruction)instr;
        if (res) {
            int ip = interp.processBlock(getLexical(), bi.getPosition());
            if (bi.isBreaked())
                return ip;
            if (elsePosition > 0) {
                instr = getLexical().getInstruction(elsePosition + 1);
                if (instr.getCode() != BeginInstruction.BEGIN_CODE)
                    throw new ScException(getErrorPos() + "@else must followed by @begin - @end block");
                return ((BeginInstruction)instr).getEndPosition() + 1;
            } else
                return ip;
        } else {
            if (elsePosition > 0) {
                instr = getLexical().getInstruction(elsePosition + 1);
                if (instr.getCode() != BeginInstruction.BEGIN_CODE)
                    throw new ScException(getErrorPos() + "@else must followed by @begin - @end block");
                bi = (BeginInstruction)instr;
                return interp.processBlock(getLexical(), bi.getPosition());
            } else
                return bi.getEndPosition() + 1;
        }
    }
    
    public void setElsePosition(int pos) {
        elsePosition = pos;
    }
}
