/*
 * Instruction.java
 *
 * Created on 16  2002 ., 9:56
 */

package com.fn.spcave.compiler;

/**
 *
 * @author  asso
 */
public class Instruction {
    
    private int line;
    private String source;
    private int code;
    private int position;
    private Object data;
    private Lexical lexical;
    
    /** Creates a new instance of Instruction */
    public Instruction(Lexical lexical, String source, int line, int position, int code) {
        this.source = source;
        this.line = line;
        this.code = code;
        this.position = position;
        this.lexical = lexical;
    }
    
    public int getCode() {
        return code;
    }
    
    public String getSource() {
        return source;
    }
    
    public int getLine() {
        return line;
    }
    
    public int getPosition() {
        return position;
    }
    
    public String getErrorPos() {
        StringBuffer sb = new StringBuffer();
        sb.append(source).append(':').append(Integer.toString(line)).append(": ");
        return sb.toString();
    }
    
    public Object getData() {
        return data;
    }
    
    public void setData(Object data) {
        this.data = data;
    }
    
    public Lexical getLexical() {
        return lexical;
    }
}
