/*
 * Utils.java
 *
 * Created on 15  2002 ., 15:24
 */

package com.fn.spcave.compiler;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author  asso
 */
public class Utils {

    static List readFunctionArgs(SourceReader sr) throws ScException {
        List args = new ArrayList();
        String s = ReaderHelper.readSymbol(sr);
        if (! s.equals("("))
            throw new ScException("Line " + Integer.toString(sr.getLineNumber()) +
                ": '(' expected but '" + s + "' found");
        ReaderHelper.skipSpaces(sr);
        int ch = sr.getChar();
        if (ch == ')')
            return args;
        else
            sr.ungetChar(ch);
        
        while (true) {
            Expression expr = new Expression(sr);
            args.add(expr);
            s = ReaderHelper.readSymbol(sr);
            if (s.equals(")"))
                break;
            if (! s.equals(","))
                throw new ScException("Line " + Integer.toString(sr.getLineNumber()) +
                    ": ',' or ')' expected but not found");
        }
        
        return args;
    }
    
}
