/*
 * GetNewsMaxYearFunction.java
 *
 * Created on 22  2002 ., 15:58
 */

package com.fn.station;


import java.util.Iterator;
import java.util.List;
import com.fn.spcave.compiler.*;


/**
 *
 * @author  asso
 */
public class GetNewsMaxYearFunction implements com.fn.spcave.compiler.FunctionHandler {
    
    /** Creates a new instance of GetNewsMaxYearFunction */
    public GetNewsMaxYearFunction() {
    }
    
    public Expression processFunction(Interpreter interp, List args) throws ScException {
        if (args.size() != 1)
            throw new ScException("@getNewsMaxYear function takes exacly one argument");
        Expression expr = (Expression)args.get(0);
        if ((! expr.isCustomType(interp)) || (! (expr.getCustomData(interp) instanceof NewsFile)))
            throw new ScException("Invalid argument of @getNewsMaxYear function");
        NewsFile nf = (NewsFile)expr.getCustomData(interp);
        int maxYear = -1;
        for (Iterator i = nf.getIterator(); i.hasNext(); ) {
            NewsFile.NewsEntry ne = (NewsFile.NewsEntry)i.next();
            if (maxYear == -1)
                maxYear = ne.year;
            else
                if (ne.year > maxYear)
                    maxYear = ne.year;
        }
        return new Expression(maxYear);
    }
    
}
